"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Service = void 0;
const signals_1 = require("./signals");
const util_1 = require("util");
class Service {
    constructor(impl) {
        this.impl = impl;
        const signals = impl.signals;
        this.close = new signals_1.Signal(signals, "close");
        this.message = new signals_1.Signal(signals, "message");
    }
    activate(cancellable) {
        return this.impl.activate(cancellable);
    }
    cancel(cancellable) {
        return this.impl.cancel(cancellable);
    }
    request(parameters, cancellable) {
        return this.impl.request(parameters, cancellable);
    }
    [util_1.inspect.custom](depth, options) {
        return "Service {}";
    }
}
exports.Service = Service;
